package main

// interface towards a cognitive apparatus

//type Utterance int
type Utterance string

type Cognition interface {
    Copy() Cognition
    Development(genome *Genome)
    DialogEnd(success bool, utterance Utterance, learningCost float64)
    GetHighestWeightedUtterance() Utterance
    GetLearnability() float64 
    GetMemory() *map[Utterance]float64
    GetMemoryWeight() float64
    SpeakToForeignerChance() float64
    GetLearnChildProbability() float64
    GetMemoryLimit() float64
    GetSpeechAbility() float64
    GetNumberOfKnownUtterances() int
    GiveFirstUtterance(utterance Utterance)
    Hear(utterance Utterance) (bool, float64)
    MakeUtterance() Utterance
    Speak() Utterance
    String() string
}
