package main

import (
    "net/http"
    "strings"
    //"path/filepath"
    "os"
    "io/ioutil"
    "fmt"
)

type HttpServer struct {
    port        string
}

func NewHttpServer() *HttpServer {
    return &HttpServer{port: "9090"}
}

var chttp = http.NewServeMux()

func (h *HttpServer) Run() {
    chttp.Handle("/", http.FileServer(http.Dir("./data/")))
    http.HandleFunc("/", Handler)
    panic(http.ListenAndServe(":"+h.port, nil))
}

func Handler(w http.ResponseWriter, r *http.Request) {
    if (strings.Contains(r.URL.Path, ".")) {
        chttp.ServeHTTP(w, r)
    } else {
        path := "data/"+r.URL.Path[1:]
        if(r.URL.Path[1:] == "") {
            fmt.Fprintf(w, "<h1>%s</h1>", "Simulations")
            fmt.Fprintf(w, "<a href=\"/current\">Latest</a><br>")
            dir, _ := ioutil.ReadDir(path)
            for _, file := range dir {
                fmt.Fprintf(w, "<a href=\"/%s\">%s</a><br>", file.Name(), file.Name())
            }
        } else {
            if(exists("data/"+r.URL.Path[1:])) {
                fmt.Fprintf(w, "<script type=\"text/javascript\" src=\"../visjs/vis.js\"></script>")
                fmt.Fprintf(w, "<h1>%s</h1><div>%s</div>", "Simulation "+r.URL.Path[1:], "")
                dir, _ := ioutil.ReadDir(path)
                for _, file := range dir {
                    if(strings.Index(file.Name(), "png") > 0) {
                        fmt.Fprintf(w, "<img src=\"/%s\"/><br>", r.URL.Path[1:]+"/"+file.Name())
                    }
                    if(strings.Index(file.Name(), "dot") > 0) {
                        filename := "data/"+r.URL.Path[1:]+"/"+file.Name()
                        buf, err := ioutil.ReadFile(filename)
                        if err != nil {
                            fmt.Println(err)
                        }
                        graphData := string(buf)
                        graphData = strings.Replace(graphData, "\n", " ", -1)
                        graphData = strings.Replace(graphData, "\t", " ", -1)
                        graphHMTL := "<div style='height:700px;width:700px;border;1px solid lightgrey' id='%s'></div>\n" +
                                    "<script type='text/javascript'>\n " +
                                      "var container = document.getElementById('%s'); \n" +
                                      "var data = { dot: '%s' }; \n" +
                                      "var options = {stabilizationIterations:200}; \n" +
                                      "var graph = new vis.Graph(container, data, options); \n" +
                                    "</script>"
                        fmt.Fprintf(w, graphHMTL, file.Name(), file.Name(), graphData)
                         
                    }
                }
            } else {
                fmt.Fprintf(w, "Not a folder")
            }
        }
    }
}

func server() {
    server := NewHttpServer()
    server.Run()
}

func exists(path string) (bool) {
    _, err := os.Stat(path)
    if err == nil { return true  }
    if os.IsNotExist(err) { return false }
    return false
}

