package main

import (
        "os"
        //"time"
        "math/rand"
        "fmt"
        "bytes"
        "os/exec"
        "strconv"
        "sort"
)

func Log(text string) {
    fmt.Println(text)
    return
    filename := "simulation.log"
    f, err := os.OpenFile(filename, os.O_APPEND|os.O_WRONLY, 0600)
    if err != nil {
        panic(err)
    }

    defer f.Close()

    if _, err = f.WriteString(text + "\n"); err != nil {
        panic(err)
    }
}

func randInt(min int , max int) int {
        max += 1
        return min + rand.Intn(max-min)
}

func randFloat() float64 {
    return rand.Float64()
    //return float64(randInt(0, 10000)) / 10000.0
}

func randomBitString(length int) string {
    var result   bytes.Buffer
    for i:=0 ; i<length ;  {
        if randInt(0,1)==1 {
        //if 1==1 {
            result.WriteString("1")
        } else {
            result.WriteString("0")
        }
        i++
    }
    resultString := result.String()
    return resultString

}

func randomBytes(length int) []byte  {
    var result bytes.Buffer
    for i:=0 ; i<length ;  {
        if randInt(0,1)==1 {
            result.WriteString("1")
        } else {
            result.WriteString("0")
        }
        i++
    }
    return result.Bytes()
}

func FloatGivenMaxIntSize(bitString string) float64 {
    length := len(bitString)
    var oneStringBuf bytes.Buffer
    for i:=0 ; i<length ;  {
        oneStringBuf.WriteString("1")
        i++
    }
    oneString := oneStringBuf.String()

    maxInt, _ := strconv.ParseInt(oneString,2, 32)
    intIn, _ := strconv.ParseInt(bitString,2, 32)

    // greycoding
    //intIn = (intIn >> 1) ^ intIn

    result := float64(intIn) / float64(maxInt)
    return result
}

// help functions for SortAgentsByFitness
type ByFitness []*Agent
func (a ByFitness) Len() int           { return len(a) }
func (a ByFitness) Swap(i, j int)      { a[i], a[j] = a[j], a[i] }
func (a ByFitness) Less(i, j int) bool { return a[i].GetFitness() > a[j].GetFitness() }
// which is here
func  SortAgentsByFitness(agents []*Agent) []*Agent{
    sort.Sort(ByFitness(agents))
    return agents
}

// help functions for SortAgentPairsByWeight
//type ByWeight []*AgentPair
//func (a ByWeight) Len() int           { return len(a) }
//func (a ByWeight) Swap(i, j int)      { a[i], a[j] = a[j], a[i] }
//func (a ByWeight) Less(i, j int) bool { return a[i].weight > a[j].weight }
//// which is here
//func  SortAgentPairsByWeight(agentPairs []*AgentPair) []*AgentPair{
//    sort.Sort(ByWeight(agentPairs))
//    return agentPairs
//}

func PrintListOfAgentsByFitness(agents []*Agent) {
    for a := range agents {
        fmt.Println(agents[a])
    }
}

func ShuffelAgentArray(src []*Agent) []*Agent {
    dest := make([]*Agent, len(src))
    perm := rand.Perm(len(src))
    for i, v := range perm {
        dest[v] = src[i]
    }
    return dest
}

func IntToString(number int) string {
    return strconv.Itoa(number)
}

func FloatToString(number float64) string {
    return strconv.FormatFloat(number, 'f', -1, 64)
}

func FileExists(name string) bool {
    if _, err := os.Stat(name); err != nil {
    if os.IsNotExist(err) {
                return false
            }
    }
    return true
}

func Move(filename, folder string) {
    cmd := exec.Command("mv", filename, folder)
    var out bytes.Buffer
    var stderr bytes.Buffer
    cmd.Stdout = &out
    cmd.Stderr = &stderr
    err := cmd.Run()
    if err != nil {
        fmt.Println(fmt.Sprint(err) + ": " + stderr.String())
        return
    }
}

func LeadingZeros(zeros int, number int) string {
    return fmt.Sprintf("%0"+IntToString(zeros)+"d", number)

}

func AvgArray(arrays [][]float64) []float64 {
    avg := make([]float64, len(arrays[0]))
    for _,array := range arrays {
        for i,element := range array {
            avg[i] += element
        }
    }
    for i, element := range avg {
        avg[i] = element/float64(len(arrays))
    }
    return avg
}

func GetColumn(board [][]float64, columnIndex int) (column []float64) {
    column = make([]float64, 0)
    for _, row := range board {
        column = append(column, row[columnIndex])
    }
    return
}

func MakeRatioArray(over []float64, under []float64) []float64 {
    newArray := make([]float64, len(over))
    for i, _ := range over {
        newArray[i] = over[i] / under[i]
    }
    return newArray
}

func MakeGeneScheme(geneLength int, genes int) []int  {
    array := make([]int, genes)
    for i,_ := range array {
        array[i] = geneLength * (i+1)
    }
    // []int{7,14,21,28,35,42, 49,56}
    return array
}

func FlipBitsByChance(bitString string, chance float64) string {
    var newBitString bytes.Buffer
    for _, c := range bitString {
        if randFloat() <= chance {
            if (string(c) == "0") {
                newBitString.WriteString("1")
            } else {
                newBitString.WriteString("0")
            }
        } else {
            newBitString.WriteString(string(c))
        }
    }
    return newBitString.String()
}
