package main

type GenerationStats struct {
    dialogsSuccessAvg     float64
    dialogsTotalAvg       float64
    fitnessAvg            float64
    fitnessStdDev         float64
    fitnessBest           float64
    learnChildAvg         float64
    learnChildStdDev      float64
    learnChildBest        float64
    memoryLimitAvg        float64
    memoryLimitStdDev     float64
    memoryLimitBest       float64
    sumWeightsAvg         float64
    sumWeightsStdDev      float64
    sumWeightsBest        float64
    ageAvg                float64
    ageStdDev             float64
    ageBest               float64
    learnabilityAvg       float64
    learnabilityStdDev    float64
    learnabilityBest      float64
    costAvg               float64
    costStdDev            float64
    costBest              float64
    extrovertAvg          float64
    extrovertStdDev       float64
    extrovertBest         float64
    speechAvg          float64
    speechStdDev       float64
    speechBest         float64
    degreeAvg             float64
    clusteringCoefAvg     float64
    knownUtterances       map[Utterance]int
    knownUtterancesCount  float64
    avgMemorySize         float64
    avgMemoryWeightSize   float64
    avgLearningBiases     []float64
}

type Population interface {
    Size() int
    Age()
    Populate()
    PrintRepresentation()
    Interact()
    KillWeak()
    Breed()
    StatsSnapshot() *Snapshot
    GetGenerationStats() GenerationStats
    GetRandomAgent() *Agent
    GetNeighbours(*Agent, bool) []*Agent
    Consensus() bool
}
