// this code was a used when testing lipowska's model in the first place
// the code is pretty bad

package main

import (
    "fmt"
    "math/rand"
    "math"
    "time"
    "bytes"
    "flag"
)


type Agent struct {
    Name  int
    X int
    Y int
    Lexicon map[string]float64
    Learnability float64
    Age int
    Alive bool
    NumberOfDialogs int
    NumberOfSuccess int
}

var matrixSize int
var iterations int
var ageFactor float64
var weightFactor float64
var mutationProb float64
var debug bool
var startWeight float64
var p float64
var individualCounter int
var learnabilityStart float64
var globalLexicon map[string]int
var globalLexiconCount int
var sleep int
var numbOfPopUpate int
var numbOfKillings int
var numbOfFailedOffspringAttempt int
var plotAgeOverLearnabilityAge, plotAgeOverLearnabilityLearnability []float64
var pSurvData []float64
var plotPoint int
var injectLearnability int


func init() {
    flag.IntVar(&matrixSize, "m", 15, "Size of matrix")
    flag.IntVar(&iterations, "i", 10000, "Number of iterations")
    flag.IntVar(&sleep, "sleep", 0, "Sleep in ms pr map update")
    flag.IntVar(&plotPoint, "plotPoint", 100, "Plot only on modulu plotPoint")
    flag.IntVar(&injectLearnability, "inject", 0, "Inject x agents with learnability 0.98 and same word")
    flag.Float64Var(&ageFactor, "a", 0.05, "How much time count in survival")
    flag.Float64Var(&weightFactor, "b", 5, "How much wordweight count in survival")
    flag.Float64Var(&mutationProb, "mut", 0.01, "Chance of mutation in offspring")
    flag.Float64Var(&startWeight, "startWeight", 0.1, "Start weight on words")
    flag.Float64Var(&learnabilityStart, "l", 0.5, "Start unit for learnability")
    flag.Float64Var(&p, "p", 0.3, "Chance of communication vs population update")
    flag.BoolVar(&debug, "debug", false, "Debugging mode")
    flag.Parse()
    individualCounter = 0
    numbOfPopUpate, numbOfKillings, numbOfFailedOffspringAttempt = 0, 0, 0
    plotAgeOverLearnabilityAge = make([]float64, iterations)
    plotAgeOverLearnabilityLearnability = make([]float64, iterations)
    pSurvData = make([]float64, iterations)
    globalLexiconCount = 1
    globalLexicon = make(map[string]int)
    globalLexicon["____"] = 0
    rand.Seed( time.Now().UTC().UnixNano())
}

func matrix(dx, dy int) ([][]Agent) {
    matrix := make([][]Agent, dx) 
         for i := range matrix {
             matrix[i] = make([]Agent, dy) 
             for j := range matrix[i] {
                 matrix[i][j] = Agent{individualCounter,  // name
                                      i,
                                      j,
                                      make(map[string]float64), // lexicon
                                      learnabilityStart, 
                                      0, // age
                                      true,
                                      0, 0} // nub dialogs, numb success
                 matrix[i][j].Lexicon[randString(4)] = startWeight
                 individualCounter+=1
             }
         }
    if (injectLearnability > 0) {
        injectWord := randString(4)
        for i := 0; i <= injectLearnability; i++ {
            x := randInt(0, matrixSize)
            y := randInt(0, matrixSize)
            matrix[x][y].Learnability = 0.98
            matrix[x][y].Lexicon[injectWord] = startWeight
        }
    }
     return matrix
}

func printMatrix(matrix [][]Agent) {
    for i := range matrix {
        for j := range matrix[i] {
            fmt.Printf("%v ", getWordWithHighestWeight(matrix[i][j].Lexicon))
        }
        fmt.Print("\n")
    }
    fmt.Print("------------------\n")
}

func getWordWithHighestWeight(lexicon map[string]float64) string {
    curWeight, curWord := -10.0, "----"
    for word, weight := range lexicon {
        if weight > curWeight {
            curWeight, curWord = weight, word
        }
    }
    return curWord
}

func randString (l int ) string         {
    var result   bytes.Buffer
    var temp string
    for i:=0 ; i<l ;  {
        if string(randInt(65,90))!=temp {
        temp = string(randInt(65,90))
        result.WriteString(temp)
        i++
      }
    }
    resultString := result.String()
    if _,ok := globalLexicon[resultString]; ok {
        // negation how
    } else {
        globalLexicon[resultString] = globalLexiconCount
        globalLexiconCount++
    }
    return resultString
}

func randInt(min int , max int) int {
        return min + rand.Intn(max-min)
}

func randAgent(matrix [][]Agent) (*Agent) {
    for true {
        x, y := randInt(0,matrixSize), randInt(0,matrixSize)
        if matrix[x][y].Alive {
            return &matrix[x][y]
        }
    }
    return nil
}

func getNeighbours(agent *Agent, matrix [][]Agent, returnOnlyAlive bool) ([]Agent)  {
    var neighbours [9]Agent
    valid := 0
    for x := -1; x <= 1; x++ {
        for y := -1; y <= 1; y++ {
            if (x == 0 && y == 0)  || x+agent.X < 0 || x+agent.X >= matrixSize ||
                           y+agent.Y < 0 || y+agent.Y >= matrixSize {
                continue
            }
            if(returnOnlyAlive) {
                if !matrix[agent.X+x][agent.Y+y].Alive {
                    continue
                }
            } else {
                if matrix[agent.X+x][agent.Y+y].Alive {
                    continue
                }
            }
            neighbours[valid] = matrix[agent.X+x][agent.Y+y]
            valid++
        }
    }
    return neighbours[0:valid]
}

func chooseWord(agent *Agent) string {
    sum := 0.0
    if len(agent.Lexicon) == 0 { panic("Trying to choose word from empty lexicon") }
    for _, weight := range agent.Lexicon {
        sum += weight
    }
    pick := float64(randInt(0, int(sum*1000))) / 1000.0
    sum = 0.0
    for word, weight := range agent.Lexicon {
        sum += weight
        if sum > pick {
            return word
        }
    }
    return "error 234"
}

func dialog(a *Agent, b *Agent) bool {
    a.Age++
    b.Age++
    word := chooseWord(a)
    a.NumberOfDialogs++
    if _,ok := b.Lexicon[word]; ok {
        // success
        a.Lexicon[word] += a.Learnability
        b.Lexicon[word] += b.Learnability
        a.NumberOfSuccess++
        b.NumberOfSuccess++
        if debug { 
            fmt.Println("Success", word)
            fmt.Println(a)
        }
        return true
    } else {
        // failed
        a.Lexicon[word] -= a.Learnability
        if a.Lexicon[word] <= 0.01 { // numbers close to 0 crashes randInt
            delete(a.Lexicon, word)
        }
        b.Lexicon[word] = startWeight
        return false
    }
    return false // should never end here
}

func initDialogWitnNeighbour(agent *Agent, matrix [][]Agent) bool {
    if len(agent.Lexicon) == 0 {
        agent.Lexicon[randString(4)] = startWeight
    }
    neighbours := getNeighbours(agent, matrix, true) // true implies alive ones
    if len(neighbours) == 0 {
        return false
    }
    randomNeighbour := &neighbours[randInt(0, len(neighbours))]
    return dialog(agent, randomNeighbour)
}

func randFloat() float64 {
    return float64(randInt(0, 10000)) / 10000.0
}

func preIteration(matrix [][]Agent) (float64, float64, float64, float64, float64, float64) {
    aliveCounter := 0.0
    sumWeight := 0.0
    sumLearnability := 0.0
    sumAge := 0.0
    sumDialog := 0.0
    sumDialogSuccess := 0.0
    for i := range matrix {
        for j := range matrix[i] {
            agent := &matrix[i][j]
            if agent.Alive {
                sumLearnability += agent.Learnability
                sumAge += float64(agent.Age)
                sumDialog += float64(agent.NumberOfDialogs)
                sumDialogSuccess += float64(agent.NumberOfSuccess)
                agentWeightSum := 0.0
                //agent.Age += 1
                aliveCounter += 1
                if(len(agent.Lexicon)) > 0 {
                    for _, weight := range agent.Lexicon {
                        agentWeightSum += weight
                    }
                    sumWeight += agentWeightSum
                }
            }
        }
    }
    sumWeightAvg := sumWeight / aliveCounter
    learnabilityAvg := sumLearnability / aliveCounter
    sumAgeAvg := sumAge / aliveCounter
    sumDialogAvg := sumDialog / aliveCounter
    sumDialogSuccessAvg := sumDialogSuccess / aliveCounter

    if debug {
        fmt.Printf("%v agents alive, avg weigh %v, learnability: %v\n", aliveCounter, sumWeightAvg, learnabilityAvg)
    }
    return aliveCounter, sumWeightAvg, learnabilityAvg, sumAgeAvg, sumDialogAvg, sumDialogSuccessAvg
}





func agentUpdate(matrix [][]Agent, agent *Agent, allAgentsAvgWeight float64) (float64) {
    sumWeight := 0.0
    if len(agent.Lexicon) > 0 {
        for _, weight := range agent.Lexicon {
            sumWeight += weight
        }
    }

    pSurv := math.Exp(-ageFactor * float64(agent.Age)) * 
                    (1 - math.Exp(-weightFactor * (sumWeight / allAgentsAvgWeight)))
    pSurvData[numbOfPopUpate] = pSurv 
    numbOfPopUpate++

    if debug { fmt.Println("kill if random is over",pSurv) }

    if randFloat() > pSurv {
        // kill
        if debug {
            fmt.Print("Dreper ", agent.Name, "\n")
        }
        agent.Alive = false
        if debug { fmt.Println("Killing agent, age:", 
               agent.Age, "l:", agent.Learnability, agent.Lexicon ) }
        agent.Lexicon["____"] = 0
        numbOfKillings++
        plotAgeOverLearnabilityAge[numbOfKillings] = float64(agent.Age)
        plotAgeOverLearnabilityLearnability[numbOfKillings] = agent.Learnability
    } else {
        deadNeighbours := getNeighbours(agent, matrix, false)  // get only dead ones
        if(len(deadNeighbours) > 0) {
            // let the agent breed
            deadAgent := deadNeighbours[randInt(0, len(deadNeighbours))]
            x, y := deadAgent.X, deadAgent.Y
            if debug { fmt.Println("Ledig på", x, ",", y) }
            if (matrix[x][y].Alive) { panic("Y u no dead") }
            matrix[x][y] = Agent{individualCounter,  // name
                                      x,
                                      y,
                                      make(map[string]float64), // lexicon
                                      learnabilityStart,
                                      0, // age
                                      true,
                                      0, 0} // numb of dialogs and successes
            individualCounter++
            if randFloat() <= mutationProb {
                // the offspring gains a new learning ability
                matrix[x][y].Learnability = randFloat()
            } else {
                // the offspirng inhertits parent's learning ability
                matrix[x][y].Learnability = agent.Learnability
            }
            if randFloat() <= mutationProb {
                // the offspirng gains a new word
                matrix[x][y].Lexicon[randString(4)] = startWeight
            } else {
                // the offsping inhertis parent's larges-weight word
                matrix[x][y].Lexicon[getWordWithHighestWeight(agent.Lexicon)] = startWeight
            }
        } else {
            numbOfFailedOffspringAttempt++
        }
    }
    return pSurv
}






func main() {
    var row, col int = matrixSize, matrixSize
    matrix := matrix(row, col)
    plotAllAgentsAvgWeigh := make([]float64, iterations/plotPoint)
    plotAllAgentsAvgLearnability := make([]float64, iterations/plotPoint)
    plotAliveAgents := make([]float64, iterations/plotPoint)
    plotAvgAge := make([]float64, iterations/plotPoint)
    plotAvgDialog := make([]float64, iterations/plotPoint)
    plotAvgDialogSuccess := make([]float64, iterations/plotPoint)
    successCounter := 0
    // map plotter
    lexiconMap := getNewMap()
    lexiconSizeMap := getNewMap()
    learnabilityMap := getNewMap()
    sumWeightsMap := getNewMap()
    ageMap := getNewMap()
    for i := 0; i < iterations; i++ {
        if i % 1000 == 0 { fmt.Println("Iteration", i) }
        aliveCounter, allAgentsAvgWeight, allAgentsAvgLearnability, allAgentsAvgAge,
                allAgentsNumbOfDialogsAvg, allAgentsNumbOfSuccessAvg := preIteration(matrix)
        if aliveCounter == 0 { break } // exit if everybody dies
        agent := randAgent(matrix) // pointer
        if debug { fmt.Println(agent.X, ",", agent.Y, " valgt") }
        if randFloat() <= p {
            if initDialogWitnNeighbour(agent, matrix) {
                successCounter++
            }
        } else {
            _ = agentUpdate(matrix, agent, allAgentsAvgWeight)
        }
        //if debug { printMatrix(matrix) }
        if(i % plotPoint == 0) {
            plotAliveAgents[i/plotPoint] = aliveCounter/float64(matrixSize*matrixSize) // scale 0-1
            plotAllAgentsAvgWeigh[i/plotPoint] = allAgentsAvgWeight
            plotAllAgentsAvgLearnability[i/plotPoint] = allAgentsAvgLearnability
            plotAvgAge[i/plotPoint] = allAgentsAvgAge
            plotAvgDialog[i/plotPoint] = allAgentsNumbOfDialogsAvg
            plotAvgDialogSuccess[i/plotPoint] = allAgentsNumbOfSuccessAvg
        }
        // update maps
        if(i % 1000 == 0) { 
            updateLexiconMap(matrix, lexiconMap, globalLexicon)
            updateLearnabilityMap(matrix, learnabilityMap)
            updateSumWeightsMap(matrix, sumWeightsMap)
            updateAgeMap(matrix, ageMap)
            updateLexiconSizeMap(matrix, lexiconSizeMap)
            time.Sleep(time.Duration(sleep) * time.Millisecond)
        }
        //if i == 50000 { p = 0.98 }
    }
//    printMatrix(matrix)
    data := make(map[string][]float64)
    data["Avg learnability"] = plotAllAgentsAvgLearnability
    data["Agents alive"] = plotAliveAgents
    plotGraph(data)
    data = make(map[string][]float64)
    data["Avg sum of weights"] = plotAllAgentsAvgWeigh
    plotGraph(data)
    data = make(map[string][]float64)
    data["Avg age"] = plotAvgAge
    plotGraph(data)
    data = make(map[string][]float64)
    data["Dialog pr agent avg"] = plotAvgDialog
    data["Success pr agent avg"] = plotAvgDialogSuccess
    plotGraph(data)
    plotGraphXY(plotAgeOverLearnabilityLearnability, plotAgeOverLearnabilityAge)
    fmt.Println("Success:", successCounter)
    fmt.Println("Number of population updates:", numbOfPopUpate)
    fmt.Println("Number of killings:", numbOfKillings)
    fmt.Println("Number of births:", individualCounter)
    fmt.Println("Number of failed offspring atempts", numbOfFailedOffspringAttempt)
    sumPSurv := 0.0
    for _,p := range pSurvData[0:numbOfPopUpate] { sumPSurv += p }
    fmt.Println("Avg pSurv:", sumPSurv/float64(numbOfPopUpate))
    //fmt.Println(plotAgeOverLearnabilityAge, plotAgeOverLearnabilityLearnability)
}
