package main

import "github.com/sbinet/go-gnuplot"
import "fmt"
import "time"

func main() {
    fname := ""
    persist := true
    debug := true

    p,err := gnuplot.NewPlotter(fname, persist, debug)
    if err != nil {
        err_string := fmt.Sprintf("** err: %v\n", err)
        panic(err_string)
    }
    defer p.Close()

    data := []float64{1,2,3,4,5,6,7,8,9,3,4,5,6,7}

    p.PlotX(data, "some data")

    for i := range data {
        time.Sleep(1 * time.Second)
        _ = p.ResetPlot()
        data[i] = 10
        p.PlotX(data, "some data")
        p.CheckedCmd("replot")
    }

    p.CheckedCmd("q")
}
